#include <PalmOS.h>





void pEvtGetEvent(void (*oldTrap)(EventType *e, Int32 timeout), void* nextRetAddr, EventType *e, Int32 timeout)
{
	oldTrap(e, timeout);
	
	while (e->eType == keyDownEvent && (e->data.keyDown.modifiers & (commandKeyMask | appEvtHookKeyMask | libEvtHookKeyMask))) {
		
		SysNotifyParamType npt;
		
		if (e->data.keyDown.chr == vchrExpCardInserted)
			npt.notifyType = sysNotifyCardInsertedEvent;
		else if (e->data.keyDown.chr != vchrExpCardRemoved)			//this weird formulation generates better code
			return;
		else
			npt.notifyType = sysNotifyCardRemovedEvent;
		
		npt.broadcaster = sysFileCExpansionMgr;
		npt.notifyDetailsP = (void*)(UInt32)e->data.keyDown.keyCode;
		npt.handled = false;
		
		SysNotifyBroadcast(&npt);
		
		oldTrap(e, timeout);
	}
}

#ifdef __GNUC__

	static void pEvtGetEventWrapper(void)
	{
		//with no "naked" attribute available, this is a bit fragile, but as long as you do not try to compile with -O0, it will be ok
		//also gcc gets too clever with tailcalls, so to avoid them, we provide a proper stack
		//sadly this means we need to create pointless stack frames
		//c'est la vie
		
		asm volatile(
			"	move.l  #0xaaaaaaaa, %d0			\n\t"		//old trap
			"	move.l  8(%sp), -(%sp)				\n\t"
			"	move.l  8(%sp), -(%sp)				\n\t"
			"	clr.l   -(%sp)						\n\t"
			"	move.l  %d0, -(%sp)					\n\t"
			"	bsr    pEvtGetEvent					\n\t"
			"	lea    16(%sp), %sp					\n\t"
		);
	}
	
#else

	asm static void pEvtGetEventWrapper(EventType *event, Int32 timeout)
	{
		move.l #0xbbbbbbbb, -(sp)		//old trap
		jsr    pEvtGetEvent
		lea    4(sp), sp
		rts
	}

#endif

void __Startup__(void)
{
	UInt32 ver;
	
	if (errNone == FtrGet(sysFtrCreator, sysFtrNumNotifyMgrVersion, &ver) && ver && errNone == FtrGet(sysFtrCreator, sysFtrNumROMVersion, &ver) && ver < sysMakeROMVersion(5, 0, 0, 0, 0)) {	//needed even in 4.0 due to our patches to ExpMgr
		
		MemSemaphoreReserve(true);
		*(volatile void**)(((UInt16*)pEvtGetEventWrapper) + 1) = SysGetTrapAddress(sysTrapEvtGetEvent);
		MemSemaphoreRelease(true);
		
		SysSetTrapAddress(sysTrapEvtGetEvent, pEvtGetEventWrapper);
		
		MemHandleLock(DmGet1Resource('extn', 14));
	}
}
