#ifndef _SD_H_
#define _SD_H_

#define SD_BLOCK_SIZE		512

union SdFlags {
	struct {
		uint8_t inited			: 1;
		uint8_t v2				: 1;
		uint8_t HC				: 1;
		uint8_t SD				: 1;
		uint8_t RO				: 1;
		uint8_t cmd23supported	: 1;
		uint8_t hasDiscard		: 1;
	};
	uint8_t value;
};

void sdHwInit(void);

bool sdCardInit(void);
uint32_t sdGetNumSecs(void);

bool sdSecRead(uint32_t sec, uint8_t *dst);
bool sdSecWrite(uint32_t sec, const uint8_t *src);

bool sdReadStart(uint32_t sec, uint32_t numSec);	//if numSec is nonzero, card will be advised to expect that many blocks
bool sdReadNext(uint8_t *dst);
bool sdReadStop(void);

void sdGetInfo(uint8_t *midP, uint16_t *oidP, uint32_t *snumP);
uint8_t sdGetFlags(void);


#endif
